#ifndef VLP_H

int learn_linear(int frame_size,
                 int vec_size,
                 int32_t frame[],
                 int32_t coeffs[]);

int blank_8_near_coeffs(int coeffs[]);

int blank_near_coeffs(int coeffs[], int gap);

int quantize_coeffs(int coeffs_size,
                    int32_t coeffs_linear[],
                    uint32_t coeffs_q_pos[],
                    uint32_t coeffs_q_neg[]);

int feed_vlp(int buffer_size,
             int32_t sample_in,
             int32_t vlp_buffer[]);

//  buffer_size is in chunks.
int convolve_vlp_signed(int buffer_size,
                        uint32_t pulses_pos[],
                        uint32_t pulses_neg[],
                        int32_t vlp_buffer[],
                        int frac_gain);

int aavg_resid_vlp(int frame_size,
                   int vec_size,
                   int32_t samples_in[],
                   uint32_t q_pos[],
                   uint32_t q_neg[],
                   int vec_gain,
                   int amp_tonal,
                   int *resid_out,
                   int *tonal_out);

#define VLP_H
#endif
